!```````````````````````````````````````````````````````````````````
module univ_numtype_constants_mod

!+ Module containing "universal" mathematical constants

use univ_kind_defs_mod, only: f8, f4, fn, i1, in, i2, i4, i8

implicit none

! "Native" 'integer':
integer(in), parameter :: huge_in = huge(1_in)

! 1-byte 'integer':
integer(i1), parameter :: huge_i1 = huge(1_i1)

! 2-byte 'integer':
integer(i2), parameter :: huge_i2 = huge(1_i2)

! 4-byte 'integer':
integer(i4), parameter :: huge_i4 = huge(1_i4)

! 8-byte 'integer':
integer(i8), parameter :: huge_i8 = huge(1_i8)


! "Native" 'real':
real(fn), parameter :: tiny_fn = tiny(1._fn),  &
                       huge_fn = huge(1._fn),  &
                       epsilon_fn = epsilon(1._fn),  &
                       oneminuseps_fn = 1._fn-epsilon_fn

! 4-byte 'real':
real(f4), parameter :: tiny_f4 = tiny(1._f4),  &
                       huge_f4 = huge(1._f4),  &
                       epsilon_f4 = epsilon(1._f4),  &
                       oneminuseps_f4 = 1._f4-epsilon_f4

! 8-byte 'real':
real(f8), parameter :: tiny_f8 = tiny(1._f8),  &
                       huge_f8 = huge(1._f8),  &
                       epsilon_f8 = epsilon(1._f8),  &
                       oneminuseps_f8 = 1._f8-epsilon_f8

end module univ_numtype_constants_mod
