!```````````````````````````````````````````````````````````````````
module univ_pointer_utils_mod

!+ Items related to dealing with Fortran-style pointers.

implicit none

interface ptr_alloc_keepdata
   module procedure ptr_alloc_keepdata_i1_1d, ptr_alloc_keepdata_i1_2d,  &
        ptr_alloc_keepdata_i1_3d, ptr_alloc_keepdata_i1_4d,  &
        ptr_alloc_keepdata_i1_5d, ptr_alloc_keepdata_i1_6d,  &
        ptr_alloc_keepdata_i1_7d
   module procedure ptr_alloc_keepdata_c_1d, ptr_alloc_keepdata_c_2d,  &
        ptr_alloc_keepdata_c_3d, ptr_alloc_keepdata_c_4d,  &
        ptr_alloc_keepdata_c_5d, ptr_alloc_keepdata_c_6d,  &
        ptr_alloc_keepdata_c_7d
   module procedure ptr_alloc_keepdata_i2_1d, ptr_alloc_keepdata_i2_2d,  &
        ptr_alloc_keepdata_i2_3d, ptr_alloc_keepdata_i2_4d,  &
        ptr_alloc_keepdata_i2_5d, ptr_alloc_keepdata_i2_6d,  &
        ptr_alloc_keepdata_i2_7d
   module procedure ptr_alloc_keepdata_i4_1d, ptr_alloc_keepdata_i4_2d,  &
        ptr_alloc_keepdata_i4_3d, ptr_alloc_keepdata_i4_4d,  &
        ptr_alloc_keepdata_i4_5d, ptr_alloc_keepdata_i4_6d,  &
        ptr_alloc_keepdata_i4_7d
   module procedure ptr_alloc_keepdata_i8_1d, ptr_alloc_keepdata_i8_2d,  &
        ptr_alloc_keepdata_i8_3d, ptr_alloc_keepdata_i8_4d,  &
        ptr_alloc_keepdata_i8_5d, ptr_alloc_keepdata_i8_6d,  &
        ptr_alloc_keepdata_i8_7d
   module procedure ptr_alloc_keepdata_f4_1d, ptr_alloc_keepdata_f4_2d,  &
        ptr_alloc_keepdata_f4_3d, ptr_alloc_keepdata_f4_4d,  &
        ptr_alloc_keepdata_f4_5d, ptr_alloc_keepdata_f4_6d,  &
        ptr_alloc_keepdata_f4_7d
   module procedure ptr_alloc_keepdata_f8_1d, ptr_alloc_keepdata_f8_2d,  &
        ptr_alloc_keepdata_f8_3d, ptr_alloc_keepdata_f8_4d,  &
        ptr_alloc_keepdata_f8_5d, ptr_alloc_keepdata_f8_6d,  &
        ptr_alloc_keepdata_f8_7d
   module procedure ptr_alloc_keepdata_b_1d, ptr_alloc_keepdata_b_2d,  &
        ptr_alloc_keepdata_b_3d, ptr_alloc_keepdata_b_4d,  &
        ptr_alloc_keepdata_b_5d, ptr_alloc_keepdata_b_6d,  &
        ptr_alloc_keepdata_b_7d
end interface

interface ptr_alloc
   module procedure ptr_alloc_i1_1d, ptr_alloc_i1_2d, ptr_alloc_i1_3d,  &
        ptr_alloc_i1_4d, ptr_alloc_i1_5d, ptr_alloc_i1_6d, ptr_alloc_i1_7d
   module procedure ptr_alloc_c_1d, ptr_alloc_c_2d, ptr_alloc_c_3d,  &
        ptr_alloc_c_4d, ptr_alloc_c_5d, ptr_alloc_c_6d, ptr_alloc_c_7d
   module procedure ptr_alloc_i2_1d, ptr_alloc_i2_2d, ptr_alloc_i2_3d,  &
        ptr_alloc_i2_4d, ptr_alloc_i2_5d, ptr_alloc_i2_6d, ptr_alloc_i2_7d
   module procedure ptr_alloc_i4_1d, ptr_alloc_i4_2d, ptr_alloc_i4_3d,  &
        ptr_alloc_i4_4d, ptr_alloc_i4_5d, ptr_alloc_i4_6d, ptr_alloc_i4_7d
   module procedure ptr_alloc_i8_1d, ptr_alloc_i8_2d, ptr_alloc_i8_3d,  &
        ptr_alloc_i8_4d, ptr_alloc_i8_5d, ptr_alloc_i8_6d, ptr_alloc_i8_7d
   module procedure ptr_alloc_f4_1d, ptr_alloc_f4_2d, ptr_alloc_f4_3d,  &
        ptr_alloc_f4_4d, ptr_alloc_f4_5d, ptr_alloc_f4_6d, ptr_alloc_f4_7d
   module procedure ptr_alloc_f8_1d, ptr_alloc_f8_2d, ptr_alloc_f8_3d,  &
        ptr_alloc_f8_4d, ptr_alloc_f8_5d, ptr_alloc_f8_6d, ptr_alloc_f8_7d
   module procedure ptr_alloc_b_1d, ptr_alloc_b_2d, ptr_alloc_b_3d,  &
        ptr_alloc_b_4d, ptr_alloc_b_5d, ptr_alloc_b_6d, ptr_alloc_b_7d
end interface

interface ptr_release
   module procedure ptr_release_i1_1d, ptr_release_i1_2d, ptr_release_i1_3d,  &
        ptr_release_i1_4d, ptr_release_i1_5d, ptr_release_i1_6d,  &
        ptr_release_i1_7d
   module procedure ptr_release_c_1d, ptr_release_c_2d, ptr_release_c_3d,  &
        ptr_release_c_4d, ptr_release_c_5d, ptr_release_c_6d, ptr_release_c_7d
   module procedure ptr_release_i2_1d, ptr_release_i2_2d, ptr_release_i2_3d,  &
        ptr_release_i2_4d, ptr_release_i2_5d, ptr_release_i2_6d,  &
        ptr_release_i2_7d
   module procedure ptr_release_i4_1d, ptr_release_i4_2d, ptr_release_i4_3d,  &
        ptr_release_i4_4d, ptr_release_i4_5d, ptr_release_i4_6d,  &
        ptr_release_i4_7d
   module procedure ptr_release_i8_1d, ptr_release_i8_2d, ptr_release_i8_3d,  &
        ptr_release_i8_4d, ptr_release_i8_5d, ptr_release_i8_6d,  &
        ptr_release_i8_7d
   module procedure ptr_release_f4_1d, ptr_release_f4_2d, ptr_release_f4_3d,  &
        ptr_release_f4_4d, ptr_release_f4_5d, ptr_release_f4_6d,  &
        ptr_release_f4_7d
   module procedure ptr_release_f8_1d, ptr_release_f8_2d, ptr_release_f8_3d,  &
        ptr_release_f8_4d, ptr_release_f8_5d, ptr_release_f8_6d,  &
        ptr_release_f8_7d
   module procedure ptr_release_b_1d, ptr_release_b_2d, ptr_release_b_3d,  &
        ptr_release_b_4d, ptr_release_b_5d, ptr_release_b_6d, ptr_release_b_7d
end interface


contains


include "univ_pointer_utils.f90.inc01"


end module univ_pointer_utils_mod
