!```````````````````````````````````````````````````````````````````
module univ_interpolation_mod

!~ 14.11.2008 (last modified; TIM)

!+ Contains routines related to interpolation and extrapolation calculations

use univ_kind_defs_mod, only: f4, f8

implicit none

private

real(f4), public, parameter :: error_val_f4 = 0.999_f4*huge(1._f4)
real(f8), public, parameter :: error_val_f8 = 0.999_f8*huge(1._f8)

interface intrp_1D_arr_type01a
   module procedure intrp_1D_arr_type01a_f4
   module procedure intrp_1D_arr_type01a_f8
end interface

interface inextrp_1D_arr_type01a
   module procedure inextrp_1D_arr_type01a_f4
   module procedure inextrp_1D_arr_type01a_f8
end interface

interface intrp_1D_pnt_type02n
   module procedure intrp_1D_pnt_type02n_f4
   module procedure intrp_1D_pnt_type02n_f8
end interface

interface intrp_2D_pnt_type01g
   module procedure intrp_2D_pnt_type01g_f4
   module procedure intrp_2D_pnt_type01g_f8
end interface

interface intrp_2D_pnt_type02g
   module procedure intrp_2D_pnt_type02g_f4
   module procedure intrp_2D_pnt_type02g_f8
end interface

public :: intrp_2D_pnt_type02g, intrp_1D_pnt_type02n, intrp_1D_arr_type01a,  &
     inextrp_1D_arr_type01a, intrp_2D_pnt_type01g

contains


include "univ_interp.f90.inc01"


end module univ_interpolation_mod
