!```````````````````````````````````````````````````````````````````
module univ_num_search_mod

!+ Contains routines related to searching numeric arrays, etcetera

!~ 13.12.2010 (last modified; TIM)

use univ_kind_defs_mod, only: f4, f8, i4, i8

implicit none

private

real(f4), public, parameter :: error_val_f4 = 0.999_f4*huge(1._f4)
real(f8), public, parameter :: error_val_f8 = 0.999_f8*huge(1._f8)
integer(i4), public, parameter :: error_val_i4 = huge(1_i4)
integer(i8), public, parameter :: error_val_i8 = huge(1_i8)

interface locidx_1D_mono_type01
   module procedure locidx_1D_mono_type01_f4i4, locidx_1D_mono_type01_f4i8,  &
        locidx_1D_mono_type01_f8i4, locidx_1D_mono_type01_f8i8
end interface

interface locidx_1D_mono_type02
   module procedure locidx_1D_mono_type02_f4i4, locidx_1D_mono_type02_f4i8,  &
        locidx_1D_mono_type02_f8i4, locidx_1D_mono_type02_f8i8
end interface

public :: locidx_1D_mono_type01, locidx_1D_mono_type02

contains


include 'univ_num_search.f90.inc01'


end module univ_num_search_mod
