!```````````````````````````````````````````````````````````````````
module univ_vector_matrix_math_mod

!+ Contains routines related to matrix/vector mathematics calculations

!~ 28.03.2010 (last modified; TIM)

implicit none

private

interface unit_normal_3vector
   module procedure unit_normal_3vector_f4, unit_normal_3vector_f8
end interface

interface f1_ex_f1
   module procedure f1_ex_f1_f4, f1_ex_f1_f8
end interface

interface solve_linear_matrix_3x3
   module procedure solve_linear_matrix_3x3_f4, solve_linear_matrix_3x3_f8
end interface

interface solve_linear_matrix_2x2
   module procedure solve_linear_matrix_2x2_f4, solve_linear_matrix_2x2_f8
end interface

interface find_inv_matrix_3x3
   module procedure find_inv_matrix_3x3_f4, find_inv_matrix_3x3_f8
end interface

interface find_inv_matrix_2x2
   module procedure find_inv_matrix_2x2_f4, find_inv_matrix_2x2_f8
end interface

public :: unit_normal_3vector, solve_linear_matrix_3x3,  &
     solve_linear_matrix_2x2, find_inv_matrix_3x3, find_inv_matrix_2x2

contains


include 'univ_vector_matrix_math.f90.inc01'


end module univ_vector_matrix_math_mod
