!```````````````````````````````````````````````````````````````````
module univ_ustarWeibull_mod

!+ Contains routines/parameters to compute sediment mass flux (saltation)
!   based on sediment saltation threshold aerodynamic friction velocities
!   (ustar, or u*) and wind distribution(s) approximated using the Weibull
!   distribution.

use univ_kind_defs_mod, only: f8, f4
   ! This needs to be here to inform the build system of a dependency: 
use univ_numtype_constants_mod, only: oneminuseps_f4

implicit none

include 'univ_ustarWeibull.f90.inc01'

interface ustWeib_intmflux_table
   module procedure ustWeib_intmflux_table_f4, ustWeib_intmflux_table_f8
end interface


contains


include 'univ_ustarWeibull.f90.inc02'


end module univ_ustarWeibull_mod
